package evoopt;



import processing.core.*;

public class Test extends PApplet
{
  public void initialisieren()
  {
    Zufall zufall;
    MeineFehlerfunktion fehlerfunktion;
    Generation generation;

    zufall = new Zufall(this,0); //immer gleicher seed!!!
//    zufall = new Zufall(this); //Millisekunden als seed!!!
    int[] arr = new int[8];
    zufall.init(arr);
    for(int i=0;i<arr.length;i++)
       System.out.print(arr[i]);
    System.out.println();       
    zufall.init(arr);
    for(int i=0;i<arr.length;i++)
       System.out.print(arr[i]);
    System.out.println();    
 
    //Klasse Gen testen
    Gen gen1 = new Gen(zufall, 8);    
    Gen gen2 = new Gen(zufall, 8);
    Gen gen3 = new Gen(zufall, 8);

    System.out.println();
    gen1.show();    
    gen2.show(); 
    gen1.mutieren(1);
    System.out.println();
    gen1.show();    
    System.out.println();
    gen3.rekombinieren(gen1,gen2);    
    gen3.show();
    
    //----Hilfsfunktion testen:----
    int[] index = new int[10];
    zufall.puzzelReihenfolge(index);
    zufall.showReihenfolge(index);    
    
    //Notwendige Objekte f&uuml;r die Optimierung anlegen:
    fehlerfunktion = new MeineFehlerfunktion(this);
    
//int anzahlgene,int anzahlbeste, int anzahlstellen, int sooftmutieren, 
//                      Zufall zufall, Fehlerfunktion fehlerfunktion)
    int anzahlgene = 10;
    int anzahlbeste = 3;
    int anzahlstellen = 8; //Anzahl der Bits der Gene
    int sooftmutieren = 20; 
   
    generation = new Generation(this,anzahlgene,anzahlbeste,anzahlstellen,sooftmutieren,zufall,fehlerfunktion);

    //Optimierung durchf&uuml;hren:
    int MAXDURCHLAEUFE = 9;
    for(int i=0;i<MAXDURCHLAEUFE;i++)
    {
        System.out.println("BESTES ERGEBNIS BEI DURCHLAUF Nr."+i+":");
        Gen bestesgen = generation.beste[0];
        fehlerfunktion.berechneUndZeige(bestesgen);
        if(i<MAXDURCHLAEUFE-1)
            generation.neueGeneration();
    }

    //Testen von Gray Code:
    Graycode graycode = new Graycode(this);
    int[] bin = {0,1,1};
    int[] gray = {0,0,0};
    graycode.bin2gray(gray,bin);
    graycode.showBitpattern(gray);
    graycode.gray2bin(bin,gray);
    graycode.showBitpattern(bin);
    
    System.out.println("*****************");    
    System.out.println("Im folgenden werden noch die Parameter-Umwandlungsmethoden in Graycode getestet:");    
    System.out.println("*****************");    
    int wert = 127;
    int maxwert = 255;
    System.out.println();
    System.out.println("Ausgangswert:"+wert);
    System.out.println("Maxwert:"+maxwert);
    int[] xbin = new int[8];
    int[] xgray = new int[8];
    graycode.int2bin(xbin,wert,0,255);
    graycode.showBitpattern(xbin);
    graycode.int2gray(xgray,wert,0,255);
    graycode.showBitpattern(xgray);
    System.out.println("R&uuml;ckwandlung von bin:"+graycode.bin2int(xbin,0,255));
    System.out.println("R&uuml;ckwandlung von gray:"+graycode.gray2int(xgray,0,255));

    wert = -5;
    int minwert = -128;
    maxwert = 127;
    
    System.out.println();
    System.out.println("Ausgangswert:"+wert);
    System.out.println("Minwert:"+minwert);
    System.out.println("Maxwert:"+maxwert);
    graycode.int2bin(xbin,wert,minwert,maxwert);
    graycode.showBitpattern(xbin);
    graycode.int2gray(xgray,wert,minwert,maxwert);
    graycode.showBitpattern(xgray);
    System.out.println("R&uuml;ckwandlung von bin:"+graycode.bin2int(xbin,minwert,maxwert));
    System.out.println("R&uuml;ckwandlung von gray:"+graycode.gray2int(xgray,minwert,maxwert));

    double dwert = 3.7;
    double dminwert = -5.0;
    double dmaxwert = 5.0;
    int[] xxbin  = new int[16];
    int[] xxgray = new int[16];

    System.out.println();
    System.out.println("Ausgangswert:"+dwert);
    System.out.println("Minwert:"+dminwert);
    System.out.println("Maxwert:"+dmaxwert);
    graycode.double2bin(xxbin,dwert,dminwert,dmaxwert);
    graycode.showBitpattern(xxbin);
    graycode.double2gray(xxgray,dwert,dminwert,dmaxwert);
    graycode.showBitpattern(xxgray);
    System.out.println("R&uuml;ckwandlung von bin:"+graycode.bin2double(xxbin,dminwert,dmaxwert));
    System.out.println("R&uuml;ckwandlung von gray:"+graycode.gray2double(xxgray,dminwert,dmaxwert));
    
    double[] param = {2.0,-3.0,4.0}; 
    double[] minparam = {-10.0,-10.0,-10.0}; 
    double[] maxparam = {10.0,10.0,10.0}; 
    System.out.println("Ausgangsparameter:");
    graycode.showParam(param);
    System.out.println("Minwert:");
    graycode.showParam(minparam);
    System.out.println("Maxwert:");
    graycode.showParam(maxparam);
    int[] xxxbin  = new int[16*param.length];
    int[] xxxgray = new int[16*param.length];
    graycode.doublearr2bin(xxxbin,param,minparam,maxparam);
    graycode.showBitpattern(xxxbin);
    graycode.doublearr2gray(xxxgray,param,minparam,maxparam);
    graycode.showBitpattern(xxxgray);
    System.out.println("R&uuml;ckwandlung von bin:");
    graycode.bin2doublearr(param,xxxbin,minparam,maxparam);
    graycode.showParam(param);
    System.out.println("R&uuml;ckwandlung von gray:");
    graycode.gray2doublearr(param,xxxgray,minparam,maxparam);
    graycode.showParam(param);
   }


  public static void main(String[] args)
  {
      Test test = new Test();
      test.initialisieren();   
  }
}

